FORMAT: 1A
HOST: https://api.golemio.cz

# Golemio permission proxy

v2.0

## Versions

<!-- __DATE__ -->




# Group Authentication

Authenticating user and verifying access token.

## Login [/gateway/login{?isAdmin}]

+ Parameters
    + isAdmin: true (boolean, optional) - restricted to admin access only

### Login [POST /gateway/login]

User signing in and returning new access token.

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)

+ Response 401 (application/json; charset=utf-8)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: user@user.com
        + password: user

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: admin@admin.com
        + password: admin

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)

+ Request (application/json; charset=utf-8)
    + Attributes
        + email: user@user.com
        + password: user

+ Response 400

### Login (admin only) [POST /gateway/login?isAdmin=true]

User signing in and returning new access token, restricted to admin access only.

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)

+ Response 401 (application/json; charset=utf-8)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: user@user.com
        + password: user

+ Response 403 (application/json; charset=utf-8)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: admin@admin.com
        + password: admin

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)

+ Request (application/json; charset=utf-8)
    + Attributes
        + email: admin@admin.com
        + password: admin

+ Response 400

## Verify token [/gateway/verify]

### Verify token [GET /gateway/verify]

Verifying the access token (token returned by login).

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401


# Group Password

Requests related to password of authenticated user.

## Change Password [POST /gateway/change-password]

Change password for authenticated user.

+ Request (application/json; charset=utf-8)
    + Attributes (ChangePassword)

+ Response 403 (application/json; charset=utf-8)

+ Request (application/json; charset=utf-8)
    + Attributes (ChangePassword)
        + old_password: user
        + new_password: user123

+ Response 204

+ Request (application/json; charset=utf-8)
    + Attributes (ChangePassword)
        + old_password: user
        + new_password: short

+ Response 400

+ Response 401


# Group Users

Users management.

## Users [/gateway/users{?page,limit,search,orderBy,orderDir}]

+ Parameters
    + page: 1 (number, optional) - Offset of records returned
    + limit: 20 (number, optional) - Number of records returned
    + search: abc (string, optional) - Fulltext search parameter
    + orderBy: created_at (enum[string], optional) - Ordering by field
        + Members
            + `email`
            + `name`
            + `surname`
            + `created_at`
            + `invitation_accepted_at`
    + orderDir: desc (enum[string], optional) - Order direction
        + Members
            + `asc`
            + `desc`

### Get All Users [GET]

Getting all existing users.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (array[UserListItem])

+ Response 401

+ Response 403

### Create New User (registration) [POST /gateway/users]

Registering the new user. This method creates new user and sends email to verify email address (invitation).

+ Request (application/json; charset=utf-8)

    + Headers

            Referer: https://domain2/client-panel
            x-access-token: fokslkdfjsdlkfjl

    + Attributes
        + email: karelploc@gmail.com (required, string)
        + password: xxx (required, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 201

+ Response 403

+ Response 409

### Create New User (admin access) [POST /gateway/users?isAdmin=true]

Creating the new user with additional admin attributes. This method creates new user and sends email to verify email address (invitation).

This process creates new user without password and the invitation record contains attribute `need_password` set on `true`.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes
        + email: karelploc@gmail.com (required, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)
        + referer: 1 (required, number)
        + roleIds: [] (required, array[number])
        + rateLimit (RateLimit)

+ Response 201

+ Response 400

+ Response 401

+ Response 403

+ Response 409

## Detail of the User [/gateway/users/{id}]

+ Parameters
    + id: 1 (required, number)

### Get User (self) [GET]

Getting informations about user.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (UserDetail)

+ Response 401

+ Response 403

+ Response 404

### Get User (admin access) [GET /gateway/users/{id}?isAdmin=true]

Getting informations about user with additional admin attributes.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (UserDetailByAdmin)

+ Response 401

+ Response 403

+ Response 404

### Edit User (self) [PUT]

Editing the user's informations.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 204

+ Response 400

+ Response 401

+ Response 403

+ Response 404

### Edit User (admin access) [PUT /gateway/users/{id}?isAdmin=true]

Editing the user's informations with additional admin attributes.

Only admin access

TODO: The admin users can set admin access to other users?

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)
        + roleIds: [] (required, array[number])
        + rateLimit (RateLimit)

+ Response 204

+ Response 400

+ Response 401

+ Response 403

+ Response 404

### Remove User [DELETE]

Removing the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

+ Response 404




# Group Api Keys

Apikeys management.

## Api Keys [/gateway/api-keys]

### Get Api Keys of the User [GET]

Returning all api keys of logged user (recognized by x-access-token).

TODO: If the logged user has admin access, all existing Api Keys containing users ids are returned.

TODO: Add filtering by user id or create endpoint `/users/{userId}/api-keys`.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Api key])

+ Response 401

### Create new Api Key for the User [POST]

Creating new Api Key for the logged user (recognized by x-access-token).

TODO: If the logged user has admin access, he can create new Api Key for the defined user (by user id).

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Api key)

+ Response 401

## Api Key Detail [/gateway/api-keys/{id}]

+ Parameters
    + id: 1 (required, number)

### Get existing Api Key of the User [GET]

TODO: Not implemented yet.

Get information about Api Key of the logged user (recognized by x-access-token).

TODO: If the logged user has admin access, he can get any existing Api Key.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (Api key)

+ Response 401

+ Response 403

+ Response 404

### Remove existing Api Key of the User [DELETE]

Removing existing Api Key of the logged user (recognized by x-access-token).

TODO: If the logged user has admin access, he can remove any existing Api Key.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 400

+ Response 401

+ Response 404




# Group Forgotten Password

Forgotten password reset process.

## Forgotten Password Request [/gateway/forgotten-password]

### Create New Password Reset Request [POST]

Creating forgotten password request and sending it by an email.

+ Request (application/json; charset=utf-8)

    + Headers

            Referer: https://domain2/client-panel

    + Attributes
        + email: karelploc@gmail.com (fixed-type, string, required)
        + `route_link`: `/auth/password-reset/` (fixed-type, string, required) - Route path which is used in email link with generated code - should navigate to your url for entering new password. Result link url consists of `Referer url` + `route_link` + `code`
        + `g-recaptcha-response`: xxxxxxx (fixed-type, string, required) - reCAPTCHA code

+ Response 201

+ Request (application/json; charset=utf-8)

    + Headers

            Referer: https://domain2/client-panel

    + Attributes
        + email: karelploc@gmail.com (fixed-type, string, required)

+ Response 400

+ Response 403

+ Response 404

## Forgotten Password Request Confirmation [/gateway/forgotten-password/{code}]

+ Parameters
    + code: `59fcf981-80a3-449d-8751-c06e161bc400` (required, string) - uuid4 format code

### Forgotten Password Code Verification [GET]

Getting information about validity of password reset code.

+ Request (application/json; charset=utf-8)

+ Response 200
    + Attributes
        + valid: false (fixed-type, boolean)
        + error: `err_already_expired` (fixed-type, string)

+ Response 403

+ Response 404

### Confirm and Set New Password [PUT]

Resets the password, if the code is valid.

+ Request (application/json; charset=utf-8)
    + Attributes
        + password: xxxx (fixed-type, string, required)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`
    + Attributes
        + password: test (fixed-type, string, required)

+ Response 204

+ Response 400




# Group Invitations

New user email verification process. Verification is represented by invitation.

## Detail of the Invitation [/gateway/invitations/{code}]

+ Parameters
    + code: `59fcf981-80a3-449d-8751-c06e161bc400` (required, string) - uuid4 format code

### Get Information about Invitation [GET]

Getting all information about invitation by code.

+ Request (application/json; charset=utf-8)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Invitation detail)

### Confirm the Invitation and Optionally Set New Password [PUT]

Confirming the user verification. If `need_password` is true, new user's password is required.

TODO: Is the PUT method correct for this case? Is the sending empty data by PUT correct?

+ Request (application/json; charset=utf-8)
    + Attributes
        + password: xxxx (fixed-type, string, optional)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`
    + Attributes
        + password: xxxx (fixed-type, string, optional)

+ Response 204

+ Response 400




# Group Rate Limits

User's rate limiting management.

## User's Rate Limit [/gateway/users/{userId}/rate-limits]

+ Parameters
    + userId: 1 (required, number)

### Get Rate Limit Information [GET]

Getting information about user's rate limit.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (RateLimit)

+ Response 403

+ response 404

### Create New Rate Limit [POST]

Creating the new rate limit for the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (RateLimit)

+ Response 204

+ Response 400

+ Response 403

+ response 404

### Edit Rate Limit [PUT]

Editing the rate limit.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (RateLimit)

+ Response 204

+ Response 400

+ Response 403

+ response 404


# Group Referer Whitelist

Management of whitelisted referers.

##  Referer Whitelist [/gateway/referer-whitelist]

### Get All Whitelisted Referers [GET]

Getting all allowed referers used when creating user from admin tools.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (array[RefererWhitelist])

+ Response 403

+ response 404


# Group Roles

User roles management.

## User Roles [/gateway/roles{?page,limit,search,orderBy,orderDir}]

+ Parameters
    + page: 1 (number, optional) - Offset of records returned
    + limit: 20 (number, optional) - Number of records returned
    + search: abc (string, optional) - Fulltext search parameter
    + orderBy: label (enum[string], optional) - Ordering by field
        + Members
            + `label`
            + `description`
            + `parent_id`
            + `parent_name`
            + `created_at`
            + `updated_at`
    + orderDir: desc (enum[string], optional) - Order direction
        + Members
            + `asc`
            + `desc`

### Get All Existing Roles [GET]

Getting existing user roles.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[RoleWithParent])

+ Response 401

+ Response 403

### Create New User Role [POST /gateway/roles]

Creating the new user role.

Only admin access

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)
        + description: `8 parkovacich mist, podelne` (nullable, optional, string) - Description of the role
        + parent_id: 1 (nullable, optional, number) - ID of parent role
        + rateLimit: (nullable, optional, RateLimit) - Rate limit for the role

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (RoleWithParentAndRateLimit)

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)
        + parent_id: 0 (nullable, optional, number)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 404

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Semafory (required, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes
        + id: 1 (fixed-type, number)
        + label: Semafory (string) - Label of the role
        + description: null (string, nullable) - Description of the role
        + parent_id: 0 (number, nullable) - Parent role id
        + parent_name: `` (string, nullable) - Parent role label
        + `default`: false (boolean)
        + rateLimit: null (nullable, optional, RateLimit) - Rate limit for the role
        + created_at: `2019-01-01 12:00:00` (string)
        + updated_at: `2019-01-01 12:00:00` (string)

+ Response 404

+ Response 401

+ Response 403

## Detail of User Role [/gateway/roles/{id}]

+ Parameters
    + id: 1 (required, number)

### Get User Role [GET]

Getting user role info by ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (RoleWithParentAndRateLimit)
        + scopes (array[Scope])

+ Response 401

+ Response 403

+ Response 404

### Edit User Role [PATCH]

Editing user role info.

Only admin access

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)
        + description: `8 parkovacich mist, podelne` (nullable, optional, string) - Description of the role
        + parent_id: 1 (nullable, optional, number) - ID of parent role
        + rateLimit: null (nullable, optional, RateLimit) - Rate limit for the role

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 404

+ Response 401

+ Response 403

### Remove User Role [DELETE]

Removing user role by ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 404

+ Response 401

+ Response 403




# Group Routes

Routing management. The routes defines proxy routing between endpoint url and target url.

## Routes [/gateway/routes{?page,limit,search,orderBy,orderDir}]

+ Parameters
    + page: 1 (number, optional) - Offset of records returned
    + limit: 20 (number, optional) - Number of records returned
    + search: abc (string, optional) - Fulltext search parameter
    + orderBy: endpoint (enum[string], optional) - Ordering by field
        + Members
            + `endpoint`
            + `method`
            + `public`
            + `target_path`
            + `target_url`
            + `is_redirect`
            + `created_at`
            + `updated_at`
    + orderDir: desc (enum[string], optional) - Order direction
        + Members
            + `asc`
            + `desc`

### Get All Routes [GET]

Getting all existing routes.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Route])

+ Response 401

+ Response 403

### Get Route Targets [GET /gateway/routes/targets]

Getting all existing route targets.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[string])

+ Response 401

+ Response 403

### Create New Route [POST /gateway/routes]

Creating new route. Combinations of the pairs `endpoint` and `method` must be unique.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + endpoint: `/parkings` (required, string)
        + target_url: `http://output.gateway.golemio.cz` (required, string)
        + target_path: `/parkoviska` (optional, string)
        + public: false (optional, boolean)
        + is_redirect: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + endpoint: `/semafory` (required, string)
        + target_url: `http://output.gateway.golemio.cz` (required, string)
        + target_path: `/semafory` (optional, string)
        + public: false (optional, boolean)
        + is_redirect: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 400

+ Response 401

+ Response 403

+ Response 409

## Detail of Route [/gateway/routes/{id}]

+ Parameters
    + id: 1 (number, required)

### Get Route [GET]

Getting the route informations by ID.

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 401

+ Response 403

+ Response 404

### Edit Route [PATCH]

Editing the route.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + endpoint: `/parkings` (required, string)
        + target_url: `http://golemio.cz/output.gateway` (required, string)
        + target_path: `/parkoviska` (optional, string)
        + public: false (optional, boolean)
        + is_redirect: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 400

+ Response 401

+ Response 403

+ Response 404

### Remove Route [DELETE]

Removing the route by ID.

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404




# Group Scopes

Link between route and user role. Scope defines limitations for user role to access the route.

TODO: should be access only by admin?

## Scopes [/gateway/roles/{roleId}/scopes]

+ Parameters
    + roleId: 1 (required, number)

### Get All Scopes [GET]

Getting all existing scopes by user role ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Scope])

+ Response 401

+ Response 403

### Create New Scope [POST]

Creating the new scope for user role. Combinations of the pairs `role` and `route` must be unique.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + route_id: 1 (number, required)
        + limitations (array)
            + (object)
                + name: districts (required, string)
                + type: `in-array` (required, enum[string])
                    + Members
                        + `min-max`
                + block: true (required, boolean)
                + source: `query` (optional, enum[string])
                    + Default: `query`
                    + Members
                        + `params`
                + values (array[string], required)
                    + `praha-1`
                    + `praha-2`
            + (object)
                + name: limit (required, string)
                + type: `min-max` (required, enum[string])
                    + Members
                        + `in-array`
                + block: false (required, boolean)
                + source: `params` (optional, enum[string])
                    + Default: `query`
                    + Members
                        + `query`
                + minMaxType: `number` (required, enum[string])
                    + Members
                        + `number`
                        + `date`
                        + `date-time`
                + min: 100 (optional, string)
                + max: 500 (optional, string)
                + default: 200 (optional, string)
            + (object)
                + name: icegateway_code (required, string)
                + type: `in-array` (required, enum[string])
                    + Members
                        + `min-max`
                + block: true (required, boolean)
                + source: `params` (optional, enum[string])
                    + Default: `query`
                    + Members
                        + `query`
                + values (array[string], required)
                    + `ICE-003-042-000-008`
                    + `ICE-003-042-000-005`

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 400

+ Response 401

+ Response 403

+ Response 409

## Detail of the Scope [/gateway/roles/{roleId}/scopes/{id}]

+ Parameters
    + roleId: 1 (required, number)
    + id: 1 (required, number)

### Get Scope Detail [GET]

Getting the scope by ID and user role ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 401

+ Response 403

+ Response 404

### Edit Scope [PATCH]

Editing the scope.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + route_id: 1 (number, required)
        + limitations (array)
            + (object)
                + name: districts (required, string)
                + type: `in-array` (required, enum[string])
                    + Members
                        + `min-max`
                + block: true (required, boolean)
                + values (array[string], required)
                    + `praha-1`
                    + `praha-2`

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 401

+ Response 403

+ Response 404

### Remove Scope [DELETE]

Removing the scope by ID and user role ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

+ Response 404

## Limitations [/gateway/limitations]

### Get All Limitations [GET]

Getting all options of limitations which can be set to the scope.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[string])

    + Body

            [
                "in-array", "min-max"
            ]

+ Response 401

+ Response 403




# Group User's Roles

User's roles management.

## User's Roles [/gateway/users/{userId}/roles]

+ Parameters
    + userId: 1 (required, number)

### Get Roles of User [GET]

Getting all user's roles.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Role])

+ Response 401

+ Response 403

+ Response 404

### Assign New Role to User [POST]

Assigning the existing user role to the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + role_id: 1 (required, number)

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Role)

+ Response 401

+ Response 403

+ Response 404

## Detail of User's Role [/gateway/users/{userId}/roles/{roleId}]

+ Parameters
    + roleId: 1 (required, number)
    + userId: 1 (required, number)

### Assign [PUT]

TODO: DEPRECATED. Incorrect implementation of the creating new resource. New implementation by POST above.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404

### Revoke Role from User [DELETE]

Revoking the user role from the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

+ Response 404




# Group User's Routes

## User's Routes [/gateway/users/{userId}/routes]

+ Parameters
    + userId: 1 (number, required)

### Get Routes of User [GET]

Getting all routes of the user. User's routes are defined by the Scope (role-route pair). This endpoint helps to determine which routes are enabled for the user.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (object)
        + endpoint: /parking (fixed-type, string)
        + method: GET (enum[string])
            + Members
                + POST
        + user_id: 1 (fixed-type, number)

+ Response 401

+ Response 403

+ Response 404





# Data Structures

## Credentials (object)
+ email: user@user.cz (fixed-type, string, required) - User login
+ password: xxxxxxx (fixed-type, string, required) - User password
+ `g-recaptcha-response`: xxxxxxx (fixed-type, string, required) - reCAPTCHA code

## ChangePassword (object)
+ old_password: xxxxxxx (fixed-type, string, required) - User's current password
+ new_password: xxxxxxx (fixed-type, string, required) - New user's password, min. length 6

## Api key (object)
+ id: 1 (fixed-type, number)
+ code: f49f03jfljfwjfjsfljf (fixed-type, string) - JWT type access token
+ user_id: 1 (fixed-type, number) - Owner id
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)

## Invitation detail (object)
+ need_password: false (fixed-type, boolean) - information if the user set his password
+ already_expired: false (fixed-type, boolean) - information if the invitation has already expired
+ already_accepted: false (fixed-type, boolean) - information if the user has already accepted the invitation into the system

## Role (object)
+ id: 3 (fixed-type, number)
+ label: Parkoviste (fixed-type, string) - Label of the role
+ description: `8 parkovacich mist, podelne` (fixed-type, string, nullable) - Description of the role
+ parent_id: 1 (fixed-type, number, nullable) - Parent role id
+ isParent: false (fixed-type, boolean)
+ `default`: false (fixed-type, boolean)
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)

## RoleWithParent (Role)
+ parent_name: `Parent` (fixed-type, string, nullable) - Parent role label

## RoleWithParentAndRateLimit (RoleWithParent)
+ rateLimit (RateLimit) - Rate limit of the role

## Route (object)
+ id: 1 (fixed-type, number)
+ endpoint: /parking (fixed-type, string)
+ target_url: `http://mojepraha.eu` (fixed-type, string)
+ target_path: `/parkoviska` (fixed-type, string)
+ public: false (fixed-type, boolean)
+ is_redirect: false (fixed-type, boolean)
+ method: GET (enum[string])
    + Members
        + POST
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)

## Scope (object)
+ id: 1 (fixed-type, number)
+ role_id: 1 (fixed-type, number)
+ route_id: 1 (fixed-type, number)
+ limitations (array)
    + (object)
        + name: districts (string)
        + type: `in-array` (string)
        + block: true (boolean)
        + source: `params` (string)
        + values (array[string])
            + `praha-1`
            + `praha-2`
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)

## UserListItem (object)
+ id: 1 (fixed-type, number)
+ email: karelploc@gmail.com (fixed-type, string)
+ name: Karel (fixed-type, string)
+ surname: Ploc (fixed-type, string)
+ roleIds: [] (fixed-type, array[number])
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ invitation_accepted_at: `2019-01-01 12:00:00` (fixed-type, string)

## UserDetail (object)
+ id: 1 (fixed-type, number)
+ email: karelploc@gmail.com (fixed-type, string)
+ name: Karel (fixed-type, string)
+ surname: Ploc (fixed-type, string)

## UserDetailByAdmin (UserDetail)
+ roleIds: [] (fixed-type, array[number])
+ rateLimit (RateLimit)
+ initial_referer: 1 (fixed-type, number)
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ invitation_accepted_at: `2019-01-01 12:00:00` (fixed-type, string)

## RateLimit (object)
+ limit: 100 (fixed-type, number, required) - number of requests per timewindow
+ timewindow: 10000 (fixed-type, number, required) - timewindow for limit in ms

## RefererWhitelist (object)
+ id: 1 (fixed-type, number, required)
+ referer: `http://someurl.com` (fixed-type, string, required)

